package com.crypto.utils.helpers;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


public class XmlReader {
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws SAXException 
	 * @throws ParserConfigurationException 
	 */

	
	
	
	public  static Map readXmlFile(String fName) throws ParserConfigurationException, SAXException, IOException
	{   Map xmlElements = new HashMap(); 
	 Map certificateElemets ;
	  
	ByteArrayInputStream f =new ByteArrayInputStream(fileToByteArray(fName));
	
		DocumentBuilder dbl = DocumentBuilderFactory.newInstance()
				.newDocumentBuilder();
		Document doc = dbl.parse(f);
		Element element = doc.getDocumentElement();
		Node rootTag=doc.getFirstChild();
		NodeList nl = rootTag.getChildNodes();
		for (int i = 0; i < nl.getLength(); i++) {
			Node e = nl.item(i);
			if (e instanceof Element) {
				if(e.getNodeName()!="Certificates")
				{
				xmlElements.put(e.getNodeName(), e.getTextContent());
				}
				else {
					
					NodeList nl_cert=	doc.getElementsByTagName("Certificate");
					for (int j = 0; j< nl_cert.getLength(); j++) {
						Node ec = nl_cert.item(j);
						if (ec instanceof Element) {
							certificateElemets=	 new HashMap(); 

							 NodeList nl_cert_sub=	ec.getChildNodes();
							  for (int k= 0; k< nl_cert_sub.getLength(); k++) {
								 
								Node ecs = nl_cert_sub.item(k);
								 if (ecs instanceof Element) {
									      
									  
									 certificateElemets.put(ecs.getNodeName(), ecs.getTextContent());
									 
									
								     }
							  }
							
							  xmlElements.put(((Element) ec).getAttribute("ID"),certificateElemets);  
							  
						}
						}
						
					}
					
					//
					
				}
				
				
			}

		
		return xmlElements;
	}	
	public static byte[]   fileToByteArray(String fName) throws FileNotFoundException, IOException {
		    File f=new File(fName);
	        FileInputStream fin = new FileInputStream(f);
	        byte[] b = new byte[(int) f.length()];
	        fin.read(b);
	        return b;
	    }
}
